class DeathParticle{
    constructor(x,y,t){
        this.x = x;
        this.y = y;
        this.t = t;
        this.r = 0;
        this.rspeed = random(-5,5);
        if(this.t === 0){
            this.yvel = random(-10,10);
            this.xvel = random(-10,10);
        }else{
            this.yvel = random(-15,15);
            this.xvel = random(-15,15);
        }
        this.f = 200;
    }
    draw(){
        noStroke();
        if(runDeathAnimation && dist(deathAnimationPosition.x,deathAnimationPosition.y,this.x,this.y) < (deathAnimationCounter * (deathAnimationCounter + 2)) / 2){
            if(this.x <= 150){
                fill(red(NIGHT_COLOR_INVERTED),green(NIGHT_COLOR_INVERTED),blue(NIGHT_COLOR_INVERTED),this.f);
            }else{
                fill(red(DAY_COLOR_INVERTED),green(DAY_COLOR_INVERTED),blue(DAY_COLOR_INVERTED),this.f);
            }
        }else{
            if(this.x <= 150){
                fill(red(NIGHT_COLOR),green(NIGHT_COLOR),blue(NIGHT_COLOR),this.f);
            }else{
                fill(red(DAY_COLOR),green(DAY_COLOR),blue(DAY_COLOR),this.f);
            }
        }
        push();
        translate(this.x,this.y);
        rotate(this.r);
        if(this.t === 0){
            rect(-5,-5,10,10);
        }else{
            rect(-2,-2,4,4);
        }
        pop();
        if(this.xvel > 0 && this.x < 158){
            this.xvel = -this.xvel;
            this.x = 142;
        }
        if(this.xvel < 0 && this.x > 142){
            this.xvel = -this.xvel;
            this.x = 158;
        }
    }
    update(){
        this.r += this.rspeed;
        this.x += this.xvel;
        this.y += this.yvel;
        this.y += runningSpeed;
        this.xvel *= 0.9;
        this.yvel *= 0.9;
        if(abs(this.xvel) < 0.2 && abs(this.yvel) < 0.2){
            this.f -= 5;
        }
    }
}// It would probably look nicer if they explode in 180 degree cone downwards and decelerate rapidly.. Make them bounce off the border between worlds. Once they decelerate completely make them fade out rapidly.

let deathParticles = [];