let DAY_COLOR;
let DAY_COLOR_FADED;
let NIGHT_COLOR;
let NIGHT_COLOR_FADED;
let DAY_COLOR_INVERTED;
let NIGHT_COLOR_INVERTED;

let canvas;
let mousePressedDown = false;
let keysTapped = [];
let keysHeld = [];
let runningSpeed = 3.5;//3.5
let speedMultiplier = runningSpeed / 3.5;
let onePointFiveSpeedMultiplier = speedMultiplier + (speedMultiplier - 1) * 2;// I don't think this is perfectly accurate but it seems to be fine...
let laneDelay = 0;
let score = 0;
let fontNormal;
let fontLight;
let scoreCounter = 0;
let twinOrbCooldown = 0;
let coinImageDay;
let coinImageNight;
let darkBackgroundParticleImage;
let runDeathAnimation = false;
let deathAnimationCounter = 0;
let deathAnimationCapture;
let deathAnimationPosition = {x: 0,y: 0};
let deathAnimationCaptureOpacity = 255;
let runTwinsAnimation = false;
let twinsAnimationCounter = 0;
let backgroundParticleTimer = 0;
let backgroundParticleCooldown = 0;
let scene = "app logo";//app logo
let postGameImage;
let postGameTimer = 0;
let click = false;
let hover = false;
let deathMessageIndex = 0;
let runTransition = false;
let transitionCounter = 0;
let transitionSpot = {x: 0,y: 0};
let transitioningTo;
let settings;
if(localStorage.getItem("fastPostGameSetting") !== null){
    settings = {
        fastPostGame: (localStorage.getItem("fastPostGameSetting") === "true" ? true : false),
        showHighscore: (localStorage.getItem("showHighscoreSetting") === "true" ? true : false)
    };
}else{
    settings = {
        fastPostGame: false,
        showHighscore: true
    };
}
let settingToggles;
let playButtonSize = 0;
let playButtonFill = 0;
let clickedPlayButton = false;
let playButtonCountdown = 0;
let menuOpacity = 255;
let pausedImg;
let questionMarkImg;
let gearImg;
let noteImg;
let displayScore = 0;
let tutorialGifs = {};
let tutorialPage = 0;
let openingAnimationCounter = 0;
let myLogoImg;
let highscore;
if(localStorage.getItem("highscore") !== null){
    highscore = localStorage.getItem("highscore");
}else{
    highscore = 0;
}
let debugging = 0;// set to 0 for no debugging, set to 1-3 for Regular Obstacle, Single-only Obstacle, Twin-only Obstacle
let tutorialPages = [
    function(x,y){
        displayGIF("jumping",x + 85,y + 350,131,131);
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);
        text("Use the arrow keys or tap the\nscreen to jump. Pressing the left\narrow key (or tapping the left side\nof the screen) will make the left\nTwin jump, and pressing the right\narrow key (or tapping the right\nside of the screen) will make the\nright Twin jump.\n\nHold for a higher, longer jump,\ntap for a lower, shorter jump.",30,125);
    },
    function(x,y){
        displayGIF("dying",x + 135,y + 100,132,265);
        displayGIF("jumpOverSpikes",x + 85,y + 400,131,131);
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);
        text("Touching\nspikes\nwill kill\nyou.",30,125);
        text("Jump over spikes to avoid dying.",30,370);
    },
    function(x,y){
        displayGIF("collectingCoins",x + 85,y + 250,132,132);
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);
        text("Collect coins to gain bonus points!",30,125);
    },
    function(x,y){
        displayGIF("twinOrbPickup",x + 85,y + 210,131,131);
        displayGIF("twinDying",x + 85,y + 400,131,131);
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);// You gain double points as long as you keep both Twins alive. Coins are also worth double when both Twins stay alive.
        text("Collect a Twin Orb to spawn a\nsecond Twin. You gain double\npoints as long as you keep both\nTwins alive.",30,125);
        text("Killing one Twin does not kill the\nother Twin.",30,350);
    },
    function(x,y){
        displayGIF("twinsExplodingFromContact",x + 85,y + 250,132,132);
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);
        text("Don't let the Twins touch each\nother! If they touch, one of them\nwill be destroyed to keep the\nother alive.",30,125);
    },
    function(x,y){
        fill(0,0,0);
        textFont(fontNormal);
        textSize(15);
        textAlign(LEFT,TOP);
        text("Try to run as far as you can, and\ncollect as many coins as you're\nable to along the way. Get the\nhighest score possible!\n\nHave fun!",30,125);
    }
];

function transitionTo(to){
    transitioningTo = to;
    transitionSpot = {x: mouseX,y: mouseY};
    transitionCounter = 0;
    runTransition = true;
}

function resetGameWorld(){
    coins = [];
    pits = [];
    spikes = [];
    twinOrbs = [];
    playerParticles = [];
    deathParticles = [];
    
    runningSpeed = 3.5;
    speedMultiplier = runningSpeed / 3.5;
    onePointFiveSpeedMultiplier = speedMultiplier + (speedMultiplier - 1) * 2;
    laneDelay = 0;
    score = 0;
    scoreCounter = 0;
    twinOrbCooldown = 0;
    runDeathAnimation = false;
    deathAnimationCounter = 0;
    deathAnimationCaptureOpacity = 255;
    runTwinsAnimation = false;
    twinsAnimationCounter = 0;
    newHighscore = false;
}

function displayGIF(name,x,y,w,h){
    fill(255,255,255);
    noStroke();
    rect(1 + x - canvas.position().x,1 + y - canvas.position().y,w - 2,h - 2);
    tutorialGifs[name].position(x,y);
    tutorialGifs[name].show();
}

function saveGame(){
    localStorage.clear();
    localStorage.setItem("fastPostGameSetting",settings.fastPostGame);
    localStorage.setItem("showHighscoreSetting",settings.showHighscore);
    localStorage.setItem("highscore",highscore);
}