let building = {
    left: 0,
    right: 0
};

function pit(y = building.right > building.left ? -building.right : -building.left){
    pits.push(new Pit(y));
}

function spike(size,side,y){
    if(typeof y === "undefined"){
        y = side === "left" ? -building.left : -building.right;
    }
    spikes.push(new Spike(y,size,side));
}

function coin(x,y){
    coins.push(new Coin(x,y));
}

function addSpace(amount,side){
    if(side === "left"){
        building.left += amount;
    }else if(side === "right"){
        building.right += amount;
    }else{
        building.left += amount;
        building.right += amount;
    }
}

let obstacles = [
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(100,"left");
        spike(1,"left");
        addSpace(80,"left");
        spike(2,"left");
        addSpace(90,"left");
        spike(1,"left");
        addSpace(60,"right");
        spike(6,"right");
        addSpace(50,"right");
        spike(1,"right");
        for(let i = 0;i < 9;i++){
            coin(150 + sin(i * 19 + 14) * 90,-175 - i * 22);
        }

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(1,"right");
        addSpace(120,"right");
        spike(2,"right");
        addSpace(90,"right");
        spike(1,"left");
        addSpace(230,"left");
        spike(1,"left");
        pit();
        addSpace(70,"left");
        spike(1,"left");
        addSpace(100,"right");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(300,"left");
        spike(1,"left");
        addSpace(200,"left");
        spike(1,"left");
        addSpace(100,"right");
        spike(3,"right");
        addSpace(300,"right");
        spike(2,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(5,"left");
        addSpace(50,"left");
        spike(5,"left");
        addSpace(90,"left");
        spike(1,"left");
        addSpace(115,"right");
        spike(1,"right");
        addSpace(150,"right");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(100,"left");
        spike(1,"left");
        addSpace(80,"left");
        spike(2,"left");
        addSpace(90,"left");
        spike(1,"left");
        addSpace(60,"right");
        spike(6,"right");
        addSpace(50,"right");
        spike(1,"right");
        for(let i = 0;i < 9;i++){
            coin(150 + sin(i * 19 + 14) * 90,-175 - i * 22);
        }

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(2,"right");
        addSpace(70,"left");
        spike(2,"left");
        addSpace(100,"right");
        spike(2,"right");
        addSpace(100,"left");
        spike(2,"left");
        addSpace(100,"right");
        spike(2,"right");
        addSpace(100,"right");
        spike(2,"right");
        addSpace(230,"left");
        spike(1,"left");
        addSpace(40,"right");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(2,"left");
        addSpace(90,"left");
        spike(3,"left");
        addSpace(70,"left");
        spike(1,"left");
        addSpace(70,"right");
        spike(1,"right");
        addSpace(120,"right");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(55,"right");
        spike(1,"right");
        addSpace(90,"left");
        spike(1,"left");
        addSpace(90,"right");
        spike(1,"right");
        addSpace(90,"left");
        spike(1,"left");
        addSpace(55,"right");
        addSpace(30,"both");
        pit();
        addSpace(70,"both");
        pit();

        addSpace(150);
    }
];

let singleOnlyObstacles = [
    function(){
        addSpace(150);

        addSpace(50,"left");
        spike(4,"left");
        spike(4,"right");
        addSpace(20,"both");
        pit();
        addSpace(30,"both");
        spike(1,"left");
        spike(1,"right");
        addSpace(100,"both");
        spike(1,"left");
        addSpace(30,"right");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(100,"right");
        spike(4,"right");
        for(let i = 0;i < 5;i++){
            coin(125,-200 - i * 27);
        }
        addSpace(160,"left");
        addSpace(80,"both");
        spike(6,"left");
        spike(6,"right");
        addSpace(10,"both");
        pit();
        spike(1,"left");
        spike(1,"right");
        addSpace(20,"both");
        spike(1,"left");
        spike(1,"right");

        addSpace(150);
    },
    function(){
        addSpace(150);

        addSpace(50,"both");
        spike(2,"left");
        spike(2,"right");
        addSpace(50,"left");
        pit();
        addSpace(50,"both");
        spike(2,"left");
        spike(2,"right");
        for(let i = 0;i < 13;i++){
            coin(150 + sin(i * 26 + 204) * 90,-154 - i * 29);
        }
        for(let i = 0;i < 6;i++){
            coin(150 + sin(i * 26 + 384) * 90,-154 - i * 29);
        }
        for(let i = 0;i < 6;i++){
            coin(150 + sin(i * 26 + 204) * 90,-355 - i * 29);
        }

        addSpace(150);
    }
];

let twinOnlyObstacles = [
    function(){
        addSpace(150);

        spike(1,"left");
        addSpace(50,"right");
        spike(1,"right");
        addSpace(60,"right");
        spike(1,"right");
        addSpace(160,"left");
        spike(1,"left");
        addSpace(60,"left");
        pit();
        for(let i = 0;i < 5;i++){
            coin(150 + sin(i * 18 + 90) * 90,-480 - i * 20);
        }
        for(let i = 0;i < 5;i++){
            coin(150 + sin(i * 18 + 270) * 90,-480 - i * 20);
        }

        addSpace(150);
    },
    function(){
        addSpace(150);

        pit();
        addSpace(30,"left");
        spike(1,"left");
        addSpace(190,"left");
        spike(1,"left");
        addSpace(70,"left");
        spike(1,"left");
        addSpace(110,"left");
        spike(7,"left");
        addSpace(110,"right");
        spike(1,"right");
        addSpace(250,"right");
        spike(1,"right");
        for(let i = 0;i < 7;i++){
            coin(175,-750 - i * 25);
        }
        for(let i = 0;i < 9;i++){
            coin(150 + sin(i * 18 + 198) * 90,-670 - i * 22);
        }

        addSpace(200);
    },
    function(){
        addSpace(150);

        addSpace(50,"both");
        addSpace(50,"left");
        spike(1,"left");
        spike(1,"right");
        for(let i = 0;i < 8;i++){
            coin(150 + sin(i * 20 + 20) * 90,-150 - i * 24);
        }
        for(let i = 0;i < 8;i++){
            coin(150 + sin(i * 20 + 200) * 90,-200 - i * 24);
        }
        addSpace(130,"both");
        addSpace(20,"right");
        spike(1,"right");
        pit();
        spike(1,"left");
        spike(1,"right");

        addSpace(150);
    }
];

















