class Player{
    
    constructor(side){
        this.size = 22;
        this.y = 475;
        this.fallingSpeed = 0;
        this.gravity = 0.28 * onePointFiveSpeedMultiplier;
        this.landed = false;
        this.jumpPower = 4.8 * speedMultiplier;
        this.possibleExtraJumpPower = 3.2 * speedMultiplier;
        this.extraJumpPowerFeedRate = 0.2 * speedMultiplier;//Good: Jump Power -> -4.8 Gravity -> 0.28 xSpeed -> 3.5 Possible Extra -> 3.2 Feed Rate -> 0.2
        this.extraJumpPowerUsed = 0;//Testing:    Jump Power -> -9.6 Gravity -> 1.12 xSpeed -> 7   Possible Extra -> 6.4 Feed Rate -> 0.4
        this.jumping = false;
        this.anim = 0;
        if(side === "left"){
            this.x = 75;
        }else{
            this.x = 225;
        }
    }
    draw(){
        noStroke();
        if(this.x <= 150){
            fill(NIGHT_COLOR_FADED);
        }else{
            fill(DAY_COLOR_FADED);
        }
        ellipse(this.x,this.y,this.size * 1.35,this.size * 1.35);
        if(this.x <= 150){
            fill(NIGHT_COLOR);
        }else{
            fill(DAY_COLOR);
        }
        ellipse(this.x,this.y,this.size,this.size);
        if(this.anim <= 0){
            playerParticles.push(new PlayerParticle(this.x,this.y));
            this.anim = 2;
        }
        this.anim--;
    }
    update(){
        if(this.x <= 150){
            this.fallingSpeed += this.gravity;
        }else{
            this.fallingSpeed -= this.gravity;
        } 
        this.x += this.fallingSpeed;
        let overPit = false;
        for(let i = 0;i < pits.length;i++){
            if(pits[i].y + pits[i].height > this.y && pits[i].y + this.size / 2 < this.y){
                overPit = true;
                this.landed = false;
            }
        }
        if(!overPit){
            if(this.x > 142 - this.size / 2 && this.x < 142 - this.size / 2 + this.fallingSpeed + 5){
                this.fallingSpeed = 0;
                this.x = 142 - this.size / 2;
                this.landed = true;
            }
            if(this.x < 158 + this.size / 2 && this.x > 158 + this.size / 2 + this.fallingSpeed - 5){
                this.fallingSpeed = 0;
                this.x = 158 + this.size / 2;
                this.landed = true;
            }
        }
        if(this.x <= 150){
            if(mouseX > 10 && mouseX < 25 && mouseY > 10 && mouseY < 30){
                mousePressedDown = false;
            }
            if(((mousePressedDown && (mouseX <= 150 || players.length === 1)) || keysTapped[LEFT_ARROW]) && this.landed){
                this.fallingSpeed = -this.jumpPower;
                this.landed = false;
                this.jumping = true;
            }
            if(this.jumping && (mouseIsPressed || keysHeld[LEFT_ARROW]) && this.extraJumpPowerUsed < this.possibleExtraJumpPower){
                this.fallingSpeed += -this.extraJumpPowerFeedRate;
                this.extraJumpPowerUsed += this.extraJumpPowerFeedRate;
            }else{
                this.jumping = false;
                this.extraJumpPowerUsed = 0;
            }
        }else{
            if(mouseX > 10 && mouseX < 25 && mouseY > 10 && mouseY < 30){
                mousePressedDown = false;
            }
            if((mousePressedDown && (mouseX > 150 || players.length === 1) || keysTapped[RIGHT_ARROW]) && this.landed){
                this.fallingSpeed = this.jumpPower;
                this.landed = false;
                this.jumping = true;
            }
            if(this.jumping && (mouseIsPressed || keysHeld[RIGHT_ARROW]) && this.extraJumpPowerUsed < this.possibleExtraJumpPower){
                this.fallingSpeed += this.extraJumpPowerFeedRate;
                this.extraJumpPowerUsed += this.extraJumpPowerFeedRate;
            }else{
                this.jumping = false;
                this.extraJumpPowerUsed = 0;
            }
        }
    }
}

let players = [];