let worldRotation = -90;// 0

function killPlayer(x,y){
    if(players.length === 1){
        runDeathAnimation = true;
        deathAnimationPosition = {x: x,y: y};
    }
    for(let i = 0;i < 7;i++){
        deathParticles.push(new DeathParticle(x,y,0));
    }
    for(let i = 0;i < 30;i++){
        deathParticles.push(new DeathParticle(x,y,1));
    }
}

function drawWorld(){
    noStroke();
    push();
    translate(150,300);
    rotate(worldRotation);
    if(worldRotation === -90){
        fill(DAY_COLOR);
        rect(-300,-150,300,300);
        fill(NIGHT_COLOR);
        rect(0,-150,300,300);
    }else if(worldRotation === 0){
        fill(DAY_COLOR);
        rect(-150,-300,150,600);
        fill(NIGHT_COLOR);
        rect(0,-300,150,600);
    }else{
        fill(DAY_COLOR);
        rect(-400,-400,400,800);
        fill(NIGHT_COLOR);
        rect(0,-400,400,800);
    }
    fill(red(NIGHT_COLOR),green(NIGHT_COLOR),blue(NIGHT_COLOR),0.5);
    for(let i = 0;i < 30;i++){
        rect(-i * 4,-400,i * 4,800);
    }
    fill(red(DAY_COLOR),green(DAY_COLOR),blue(DAY_COLOR),0.6);
    for(let i = 0;i < 30;i++){
        rect(0,-400,i * 3.5,800);
    }
    if(worldRotation === 0){
        fill(DAY_COLOR);
        rect(0,-300,8,600);
        fill(NIGHT_COLOR);
        rect(-8,-300,8,600);
    }
    for(let i = 0;i < backgroundParticles.length;i++){
        backgroundParticles[i].update();
        backgroundParticles[i].draw();
        if(backgroundParticles[i].y > 620){
            backgroundParticles.splice(i,1);
            i--;
        }
    }
    pop();
    
    if(backgroundParticleTimer > backgroundParticleCooldown){
        backgroundParticleCooldown = floor(random(30,85));
        backgroundParticleTimer = 0;
        backgroundParticles.push(new BackgroundParticle(random(-20,80)));
    }
    if(backgroundParticleTimer % 25 === 0){
        backgroundParticles.push(new BackgroundParticle(random(170,300)));
        backgroundParticleTimer++;
    }
}

function runWorld(){
    for(let i = 0;i < spikes.length;i++){
        spikes[i].update();
        spikes[i].draw();
        if(spikes[i].y > 600){
            spikes.splice(i,1);
            i--;
        }
    }
    
    for(let i = 0;i < pits.length;i++){
        pits[i].update();
        pits[i].draw();
        if(pits[i].y > 600){
            pits.splice(i,1);
            i--;
        }
    }
    
    for(let i = 0;i < twinOrbs.length;i++){
        twinOrbs[i].update();
        if(twinOrbs.length > 0){
            twinOrbs[i].draw();
        }
        if(twinOrbs.length > 0 && twinOrbs[i].y > 616){
            twinOrbs.splice(i,1);
            i--;
        }
    }
    
    for(let i = 0;i < coins.length;i++){
        coins[i].update();
        coins[i].draw();
        let collided = false;
        for(let j = 0;j < players.length;j++){
            let player = players[j];
            if(dist(coins[i].x,coins[i].y,player.x,player.y) < player.size / 2 + 7){
                score += players.length === 1 ? 2 : 4;
                coins.splice(i,1);
                i--;
                collided = true;
                break;
            }
        }
        if(!collided && coins[i].y > 615){
            coins.splice(i,1);
            i--;
        }
    }
    
    if(!runDeathAnimation){
        for(let i = 0;i < playerParticles.length;i++){
            playerParticles[i].draw();
            playerParticles[i].update();
            if(playerParticles[i].y > 605){
                playerParticles.splice(i,1);
                i--;
            }
        }
    }
    
    for(let i = 0;i < players.length;i++){
        players[i].draw();
        players[i].update();
    }
    if(players.length > 1){
        if(players[0].x + players[0].size / 4 > players[1].x - players[1].size / 4 && players[0].x - players[0].size / 4 < players[1].x + players[1].size / 4){
            if(abs(players[1].fallingSpeed) > abs(players[0].fallingSpeed)){
                killPlayer(players[0].x,players[0].y);
                players.splice(0,1);
            }else{
                killPlayer(players[1].x,players[1].y);
                players.splice(1,1);
            }
        }
    }
    
    if(laneDelay < 0){
        if(players.length === 1 && twinOrbCooldown < 0){
            if(random(0,1) > 0.9){
                twinOrbs.push(new TwinOrb(-20,random(0,1) >= 0.5 ? "left" : "right"));
                addSpace(40);
                twinOrbCooldown = 7000;
            }
        }
        if(!debugging){
            if(random(0,1) > 0.9){
                if(players.length > 1){
                    if(random(0,1) > 0.6){
                        twinOnlyObstacles[floor(random(0,twinOnlyObstacles.length))]();
                    }else{
                        obstacles[floor(random(0,obstacles.length))]();
                    }
                }else{
                    if(random(0,1) > 0.6){
                        singleOnlyObstacles[floor(random(0,singleOnlyObstacles.length))]();
                    }else{
                        obstacles[floor(random(0,obstacles.length))]();
                    }
                }
            }else{
                addSpace(50);
                let rand = random(0,1);
                if(rand > 0.8){
                    if(random(0,1) > 0.5){
                        spike(floor(random(1,6)),"left");
                    }else{
                        spike(floor(random(1,6)),"right");
                    }
                }else if(rand > 0.6){
                    let rando = random(1,5);
                    spike(rando,"left");
                    spike(rando,"right");
                }else if(rand > 0.4){
                    if(random(0,1) > 0.5){
                        spike(floor(random(1,6)),"left");
                        spike(floor(random(1,6)),"right",random(-70,10));
                    }else{
                        spike(floor(random(1,6)),"right");
                        spike(floor(random(1,6)),"left",random(-70,10));
                    }
                }else if(rand > 0.1){
                    if(players.length === 1){
                        pit();
                        coin(150,(y = building.right > building.left ? -building.right : -building.left) + 37);
                    }else{
                        pit();
                    }
                }else{
                    let len = floor(random(2,6));
                    if(random(0,1) > 0.5){
                        for(let i = 0;i < len;i++){
                            coin(125,-i * 30 - 50);
                        }
                    }else{
                        for(let i = 0;i < len;i++){
                            coin(175,-i * 30 - 50);
                        }
                    }
                    addSpace(len * 30);
                }
                addSpace(50);
            }
            laneDelay = building.right > building.left ? building.right : building.left;
            building = {
                left: 0,
                right: 0
            };
        }else{
            if(debugging === 1){
                obstacles[0]();
            }else if(debugging === 2){
                singleOnlyObstacles[0]();
            }else{
                twinOnlyObstacles[0]();
            }
            laneDelay = building.right > building.left ? building.right : building.left;
            building = {
                left: 0,
                right: 0
            };
        }
    }
    if(players.length === 1){
        twinOrbCooldown -= runningSpeed;
    }
    laneDelay -= runningSpeed;
}













