class SettingToggle{
    constructor(setting,label){
        this.setting = setting;
        this.label = label;
        this.anim = (settings[setting] ? 1 : 0);
        this.size = 36;
    }
    draw(y){
        if(settings[this.setting]){
            this.anim += (1 - this.anim) / 10;
        }else{
            this.anim += -this.anim / 10;
        }
        noFill();
        let c = lerpColor(NIGHT_COLOR,DAY_COLOR,constrain(this.anim,0.3,0.8));
        stroke(c);
        strokeWeight(30);
        line(200,y,250,y);
        noStroke();
        c = lerpColor(NIGHT_COLOR,DAY_COLOR,this.anim);
        fill(red(c),green(c),blue(c),75);
        ellipse(200 + this.anim * 50,y,this.size,this.size);
        fill(c);
        ellipse(200 + this.anim * 50,y,25,25);
        textFont(fontLight);
        textSize(20);
        textAlign(RIGHT,CENTER);
        fill(0,0,0);
        text(this.label,175,y - 5);
        if((mouseX > 200 && mouseX < 250 && mouseY > y - 15 && mouseY < y + 15) || dist(200,y,mouseX,mouseY) < 15 || dist(250,y,mouseX,mouseY) < 15){
            this.size += (40 - this.size) / 5;
            cursor("pointer");
            hover = true;
            if(click){
                settings[this.setting] = !settings[this.setting];
                saveGame();
            }
        }else{
            this.size += (36 - this.size) / 5;
        }
    }
}